
# Import arcpy module
import arcpy

arcpy.env.overwriteoutput = True;

path="C:\\Users\\00jdunca\\OfflineDocuments\\ForestHealthAtlas3\\VtReprocessing\\VTADS2.gdb\\ADS\\"
finalFields=["OBJECTID","SHAPE","Shape","FID","DATE","DCA1","DCA2","DCA3","DMG","DMG_TYPE1","DMG_TYPE2","DMG_TYPE3","DMGNAME","DMGPATT","DMGSEV","DMGTYP","DMGTYPE","FOR_TYPE1","FOR_TYPE2","FOR_TYPE3","HOST1","HOST2","HOST3","NO_TREES1","NO_TREES2","NO_TREES3","NOTES","PATTERN1","PATTERN2","PATTERN3","PCT_MORT1","PCT_MORT2","PCT_MORT3","RPT_YR","SEVERITY1","SEVERITY2","SEVERITY3","Shape_Area","Shape_Length","STATE","SURVEY_ID1","SURVEY_ID2","SURVEY_ID3","SURVEYOR","TPA1","TPA2","TPA3","VTDMGAGT","VTDMGHOST","VTDMGSEV","VTDMGTYP","VTHOST"]
#if starting from scratch, 2015 DMGNAME was put in NOTES field, needs to be updated
process2015=False
#if starting from scratch, need to process 2014 a bit, set below bit to true
process2014=False
#If starting from scratch, need to delete row from 1996 where year = 0
process1996=False
#If starting from scratch, need to create expected rows in the 2016 data
process2016=False
#2014 data don't come with dmgname, so these map legend to dmg name
dmgMatch={'Discoloration from hardwood anthracnose on hardwoods':'Anthracnose','Discoloration from anthracnose on willow':'Willow Defoliation','Mortality from beech bark disease on American beech':'Beech Bark Disease','Dieback from beech bark disease on American beech':'Beech Bark Disease','Defoliation from birch leaf fungus on paper birch':'Birch Leaf Fungi', 'Defoliation from hardwood anthracnose on hardwoods':'Anthracnose','Defoliation from brown spot needle blight and Defoliation from Diplodia canker on red pine':'Red Pine Symptoms','Discoloration from brown spot needle blight on Scotch pine':'Brown Spot Needle Blight','Discoloration from brown spot needle blight on eastern white pine':'Brown Spot Needle Blight','Discoloration from white pine needle cast on eastern white pine':'Brown Spot Needle Blight','Discoloration from decline on hardwoods':'Hardwood Decline','Defoliation from oak leafroller on northern red oak':'Oak Defoliator Complex','Discoloration from flooding-high water on hardwoods':'Wet Site Related Decline','Defoliation from hail on hardwoods':'Hail Damage','Dieback from hemlock woolly adelgid on hemlock':'Hemlock Woolly Adelgid','Dieback from snow-ice on hardwoods':'Ice/Snow Damage','Dieback from snow-ice on hardwoods':'Ice/Snow Damage','Mortality from snow-ice on red pine':'Ice/Snow Damage','Defoliation from locust leafminer on black locust':'Locust Leafminer','Dieback from logging damage on hardwoods':'Logging Related Decline','Mortality from unknown decline/complex/wilt on balsam fir':'Spruce-Fir Decline','Mortality from unknown decline/complex/wilt on red pine':'Red Pine Symptoms','Mortality from unknown decline/complex/wilt on eastern white pine':'White Pine Symptoms','Mortality from unknown decline/complex/wilt on softwoods':'Spruce-Fir Decline','Mortality from unknown decline/complex/wilt on softwoods':'Spruce-Fir Decline','Previously Undocumented Mortality from birch leaf fungus on paper birch':'Birch Decline','Previously Undocumented Mortality from unknown decline/complex/wilt on softwoods':'Spruce-Fir Decline','Defoliation from saddled prominent on sugar maple':'Saddled Prominent','Mortality from flooding-high water on hardwoods':'Wet Site Related Decline','Mortality from flooding-high water on eastern white pine':'Wet Site Related Decline','Mortality from flooding-high water on softwoods':'Wet Site Related Decline','Mortality from wind-tornado/hurricane on hardwoods':'Wind Damage','Mortality from wind-tornado/hurricane on softwoods':'Wind Damage','Discoloration from white pine needle cast on eastern white pine':'Brown Spot Needle Blight','Mortality from white pine blister rust on eastern white pine':'White Pine Blister Rust'}

# Local variables:
VT_2015_ADS_ALL_Final = "VT_2015_ADS_ALL_Final"
vt_defol1985 = "vt_defol1985"
vt_defol1986 = "vt_defol1986"
vt_defol1987 = "vt_defol1987"
vt_defol1988 = "vt_defol1988"
vt_defol1989 = "vt_defol1989"
vt_defol1990 = "vt_defol1990"
vt_defol1991 = "vt_defol1991"
vt_defol1992 = "vt_defol1992"
vt_defol1993 = "vt_defol1993"
vt_defol1994 = "vt_defol1994"
vt_defol1995 = "vt_defol1995"
vt_defol1996 = "vt_defol1996"
vt_defol1997 = "vt_defol1997"
vt_defol1998 = "vt_defol1998"
vt_defol1999 = "vt_defol1999"
vt_defol2000 = "vt_defol2000"
vt_defol2001 = "vt_defol2001"
vt_defol2002 = "vt_defol2002"
vt_defol2003 = "vt_defol2003"
vt_defol2004 = "vt_defol2004"
vt_defol2005 = "vt_defol2005"
vt_defol2006 = "vt_defol2006"
vt_defol2007 = "vt_defol2007"
vt_defol2008 = "vt_defol2008"
vt_defol2009 = "vt_defol2009"
vt_defol2010 = "vt_defol2010"
vt_defol2011 = "vt_defol2011"
vt_defol2012 = "vt_defol2012"
vt_defol2013 = "vt_defol2013"
vt_defol2014 = "vt_defol2014"
AerialSurveys_1985_2015 = "AerialSurveys_1985_2015"
OutFileName="AerialSurveys_1985_2016"
VT_2016_IDS = "VT_2016_IDS"

arcpy.env.workspace=path
files=arcpy.ListFeatureClasses("*")
print files
merges=[]

print arcpy.env.workspace
#Add field to 2014 for DMGNAME
#If starting from scratch, set conditional above to allow this to run 
if process1996 == True:
	rows = arcpy.UpdateCursor(vt_defol1996, "", "", "RPT_YR","")
	for row in rows:
		if row.RPT_YR==0:
			rows.deleteRow(row)
if process2014==True: 
	arcpy.AddField_management(vt_defol2014,'DMGNAME','TEXT',50)
	rows = arcpy.UpdateCursor(vt_defol2014, "", "", "DMGNAME,Legend","")
	for row in rows:
		row.DMGNAME=dmgMatch[row.Legend]
		rows.updateRow(row)

if process2015 == True:
	arcpy.AddField_management(VT_2015_ADS_ALL_Final,'DMGNAME','TEXT',50)
	rows = arcpy.UpdateCursor(VT_2015_ADS_ALL_Final, "", "", "DMGNAME,NOTES","")
	for row in rows:
		row.DMGNAME=row.NOTES.strip()
		rows.updateRow(row)
if process2016 == True:
	#DCA1, DCA2, DMG_TYPE1, HOST1, FOR_TYPE1, STATE
	arcpy.AddField_management(VT_2016_IDS,'DMGNAME','TEXT',50)
	arcpy.AddField_management(VT_2016_IDS,'DCA1','LONG',10)
	arcpy.AddField_management(VT_2016_IDS,'DCA2','LONG',10)
	arcpy.AddField_management(VT_2016_IDS,'DMG_TYPE1','LONG',5)
	arcpy.AddField_management(VT_2016_IDS,'HOST1','LONG',5)
	arcpy.AddField_management(VT_2016_IDS,'FOR_TYPE1','LONG',5)
	arcpy.AddField_management(VT_2016_IDS,'STATE','TEXT',50)
	arcpy.AddField_management(VT_2016_IDS,'RPT_YR','SHORT')
	rows = arcpy.UpdateCursor(VT_2016_IDS, "", "", "DMGNAME,NOTES,DCA1,DCA2,DCA_CODE,DMG_TYPE1, DAMAGE_TYP,HOST1,HOST_CODE,FOR_TYPE1,STATE,RPT_YR","")
	for row in rows:
		row.DMGNAME=row.NOTES.strip()
		row.DCA1=row.DCA_CODE
		row.DCA2=99999
		row.DMG_TYPE1=row.DAMAGE_TYP
		row.HOST1=row.HOST_CODE
		row.FOR_TYPE1=9999
		row.STATE="VT"
		row.RPT_YR=2016
		rows.updateRow(row)
		
#Loop through files and delete fields that are not in the final list
for file in files:
	#Make a working copy
	arcpy.Copy_management(file, file+"_working")
	merges.append(file+"_working")
	field_list = arcpy.ListFields(file)
	for field in field_list:
		if field.name not in finalFields and "OBJECTID" not in field.name:
			print "Deleting field " + field.name + " in file "+file
			arcpy.DeleteField_management(file+"_working",  field.name )
			
inputs=";".join(merges)
arcpy.Merge_management(merges,OutFileName)

#Add area calculations
arcpy.AddField_management(OutFileName,'Area_Ac','Long',10)
arcpy.AddField_management(OutFileName,'Area_Ha','Long',10)
arcpy.CalculateField_management(OutFileName, "Area_Ac","!SHAPE.AREA@ACRES!","PYTHON_9.3")
arcpy.CalculateField_management(OutFileName, "Area_Ha","!SHAPE.AREA@HECTARES!","PYTHON_9.3")

for file in files:
	arcpy.Delete_management(file+"_working")
	