import arcpy
filelist=["vt_defol1985","vt_defol1986","vt_defol1987","vt_defol1988","vt_defol1989","vt_defol1990","vt_defol1991","vt_defol1992","vt_defol1993","vt_defol1994"]

agtcodes={'ALM': 12026,'Anth': 25025,'AY': 24004,'BBD': 22042,'BLF': 25076,'BLM': 25001,'BLS': 12070,'BSW': 12120,'Bvr': 41002,'BWA': 14003,'Cns': 70006,'CSSM': 12081,'DED': 24022,'Drt': 50003,'ELB': 12141,'ETC': 12093,'FCW': 12014,'Frst': 50005,'FTC': 12096,'FWW': 12082,'Fyr': 30000,'GM': 12089,'Hail': 50006,'HL': 12083,'Ice': 50011,'LAT': 12037,'LC': 12047,'LD': 24011,'LLM': 12119,'Log': 70007,'MLC': 12127,'MS': 14051,'Mse': 41004,'Ndc': 25005,'Oys': 14028,'PG': 12130,'PLF': 25036,'Porc': 41006,'SAS': 12167,'Sat': 12086,'SBW': 12038,'Scb': 25004,'See': 50800,'Sno': 50011,'SP': 12079,'SWI': 50014,'Thr': 14058,'Wet': 50004,'Wnd': 50013,'ZPM': 15022}
hostcodes={'Ald': 350,'Apl': 660,'Ash': 541,'Be': 531,'BL': 901,'Bnt': 601,'Brc': 375,'Chy': 760,'Elm': 970,'F': 12,'Hk': 261,'Hwd': 1,'Lch': 71,'Mr': 316,'Ms': 318,'Mxd': 3,'Oak': 833,'Pin': 100,'Pop': 740,'Pr': 125,'Pw': 129,'SF': 2,'Spr': 90,'Sr': 97,'Sw': 94,'Swd': 2,'Wlw': 920}
hostexceptions=['Cdr']
dmgcodes={'bld': 7,'brk': 6,'brn': 3,'chl': 3,'col': 3,'def': 1,'dk': 4,'nDd': 2,'oDd': 11,'un': 9,'unk': -1}
dmgexceptions=['thn']


for filename in filelist:
        file="I:\Administration\jim_docs\FPRAerialSurveys\VT Aerial Survey Data Archive\\"+filename+".shp"
        rows = arcpy.UpdateCursor(file, "", "", "VTDMGAGT, VTHOST, VTDMGTYP,DCA1,DCA2,HOST1,DMG_TYPE1, FOR_TYPE1","")
        for row in rows:

                ##Update the damage agent codes
                if row.VTDMGAGT in agtcodes:
                        #Set the DCA value to the value matched to the Agent Code key
                        row.DCA1 = agtcodes[row.VTDMGAGT]
                        #Check if the code is Combined Phigalia/Gypsy Moth, and if so, add additional agent in DCA2 column for Gypsy Moth
                        if row.VTDMGAGT=="PG":
                                row.DCA2 = 12089
                else:
                        ##Set the DCA value to 99999, which is the code for "No Data", corresponding to when there is an unknown or null value in VT code
                        row.DCA1 = 99999

                ##Update the host codes
                if row.VTHOST in hostcodes:
                        #Set the HOST1 value to the value matched to the Host Code key
                        row.HOST1 = hostcodes[row.VTHOST]
                        #Check if host is Spruce-Fir, if it is, also need to set FOR_TYPE1 to 0100
                        if row.VTHOST=="SF":
                                row.FOR_TYPE1=100
                elif row.VTHOST in hostexceptions: #The match for this value depends on other context, so flag it for review
                        #If the host is cedar and the dmgtype is Arborvitae Leaf Miner, then the Host is 241, Northern White Cedar
                        if row.VTHOST=="Cdr" and row.VTDMGAGT=="ALM":
                                row.HOST1 = 241
                        else:
                                row.HOST1 = -99
                else:
                        ##Set the HOST1 value to -1, which is the code for "No Data", corresponding to when there is an unknown or null value in VT code
                        row.HOST1 = -1
                        
                ##Update the damage type codes
                if row.VTDMGTYP in dmgcodes:
                        #Set the DMG_TYPE1 value to the value matched to the Damage Code key
                        row.DMG_TYPE1 = dmgcodes[row.VTDMGTYP]
                elif row.VTDMGTYP in dmgexceptions: #The match for this value depends on other context, so flag it for review
                        row.DMG_TYPE1 = -9
                else:
                        ##Set the DMG_TYPE1 value to -1, which is the code for "No Data", corresponding to when there is an unknown or null value in VT code
                        row.DMG_TYPE1 = -1
                        
                rows.updateRow(row)
del row
del rows

        
